commit 684a5a8734c4269786089f5d4ba0fbf79f190f3a
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Wed Feb 1 21:01:32 2023 +0100

    Fortran: error recovery on invalid array section [PR108609]
    
    The testcase for PR108527 uncovered a latent issue with invalid array
    sections that resulted in different paths being taken on different
    architectures.  Detect the invalid array declaration for a clean recovery.
    
    gcc/fortran/ChangeLog:
    
            PR fortran/108609
            * expr.c (find_array_section): Add check to prevent interpreting an
            mpz non-integer constant as an integer.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/108609
            * gfortran.dg/pr108527.f90: Adjust test pattern.
    
    (cherry picked from commit 88a2a09dd4529107e7ef7a6e7ce43acf96457173)

diff --git a/gcc/fortran/expr.c b/gcc/fortran/expr.c
index b65fc764fb8..5f22270c2f0 100644
--- a/gcc/fortran/expr.c
+++ b/gcc/fortran/expr.c
@@ -1549,7 +1549,11 @@ find_array_section (gfc_expr *expr, gfc_ref *ref)
       lower = ref->u.ar.as->lower[d];
       upper = ref->u.ar.as->upper[d];
 
-      if (!lower || !upper)
+      if (!lower || !upper
+	  || lower->expr_type != EXPR_CONSTANT
+	  || upper->expr_type != EXPR_CONSTANT
+	  || lower->ts.type != BT_INTEGER
+	  || upper->ts.type != BT_INTEGER)
 	{
 	  t = false;
 	  goto cleanup;
diff --git a/gcc/testsuite/gfortran.dg/pr108527.f90 b/gcc/testsuite/gfortran.dg/pr108527.f90
index c97ba3111cb..804514810ac 100644
--- a/gcc/testsuite/gfortran.dg/pr108527.f90
+++ b/gcc/testsuite/gfortran.dg/pr108527.f90
@@ -4,7 +4,7 @@
 
 program p
   integer, parameter :: a((2.)) = [4,8] ! { dg-error "must be of INTEGER type" }
-  integer(a(1:1)) :: b                  ! { dg-error "out of bounds" }
+  integer(a(1:1)) :: b                  ! { dg-error "Unclassifiable statement" }
 end
 
 ! { dg-prune-output "Parameter array" }

